Summary: Common Unix Printing System
Name: cups
Version: 1.1.19
Release: 7tr
License: GPL
Group: System/Daemons
Source: ftp://ftp.easysw.com/pub/cups/cups-%{version}-source.tar.bz2
Source1: cups.init
Source2: cupsprinter.png
Source5: cups-lpd
Source8: postscript.ppd.gz
Source9: cups.logrotate
Source10: ncp.backend
Patch0: cups-1.1.19-initscript.patch
Patch1: cups-1.1.14-doclink.patch
Patch3: cups-1.1.17-backend.patch
Patch6: cups-1.1.17-pdftops.patch
Patch9: cups-1.1.19-ppdsdat.patch
Patch10: cups-1.1.20-CAN-2004-0558.patch
Url: http://www.cups.org/
BuildRoot: %{_tmppath}/%{name}-root
PreReq: /sbin/chkconfig /sbin/service /sbin/restart_maybe
Requires: %{name}-libs = %{version} xinetd libjpeg libtiff
Requires: ghostscript-cups
Provides: lpd lpr lprng
BuildPrereq: pam-devel openssl-devel

%package devel
Summary: Common Unix Printing System - development environment
Group: Libraries/Development
Requires: %{name}-libs = %{version} libjpeg libtiff

%package libs
Summary: Common Unix Printing System - libraries
Group: Libraries/Runtime

%description
The Common UNIX Printing System provides a portable printing layer for 
UNIX operating systems. It has been developed by Easy Software Products 
to promote a standard printing solution for all UNIX vendors and users. 
CUPS provides the System V and Berkeley command-line interfaces. 

%description devel
The Common UNIX Printing System provides a portable printing layer for 
UNIX operating systems. This is the development package for creating
additional printer drivers, and other CUPS services.

%description libs
The Common UNIX Printing System provides a portable printing layer for 
UNIX operating systems. It has been developed by Easy Software Products 
to promote a standard printing solution for all UNIX vendors and users. 
CUPS provides the System V and Berkeley command-line interfaces. 
The cups-libs package provides libraries used by applications to use CUPS
natively, without needing the lp/lpr commands.

%prep
%setup -q
%patch0 -p1 -b .noinit
%patch1 -p1 -b .doclink
%patch3 -p1 -b .backend
%patch6 -p1 -b .pdftops
%patch9 -p1 -b .ppdsdat
%patch10 -p1
perl -pi -e 's,^#(Printcap\s+/etc/printcap),$1,' conf/cupsd.conf.in
autoconf

cp %{SOURCE5} cups-lpd.real
perl -pi -e "s,\@LIBDIR\@,%{_libdir},g" cups-lpd.real

%build
%configure --with-docdir=%{_docdir}/cups-%{version} --localstatedir=%{_var}
perl -pi -e "s,^DSO	=.*,DSO=gcc -fpic," Makedefs

# If we got this far, all prerequisite libraries must be here.
make OPTIM="$RPM_OPT_FLAGS $CFLAGS -fpic"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_initdir}

make BUILDROOT=$RPM_BUILD_ROOT install 

install -m 755 $RPM_SOURCE_DIR/cups.init $RPM_BUILD_ROOT%{_initdir}/cups

find $RPM_BUILD_ROOT/usr/share/cups/model -name "*.ppd" |xargs gzip -9f

mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d $RPM_BUILD_ROOT/var/spool/cups/tmp $RPM_BUILD_ROOT/var/log/cups
install -c -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/pixmaps
install -c -m 755 cups-lpd.real $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/cups-lpd
install -c -m 755 %{SOURCE9} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/cups
install -c -m 755 %{SOURCE10} $RPM_BUILD_ROOT%{_libdir}/cups/backend/ncp
ln -s ../doc/%{name}-%{version} $RPM_BUILD_ROOT%{_datadir}/%{name}/doc
# Deal with users trying to access the admin tool at
# /usr/share/doc/cups-%{version}/index.html rather than the
# correct http://localhost:631/
for i in admin classes jobs printers; do
	mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/$i
	cat >$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/$i/index.html <<EOF
<?xml version="1.0"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/transitional.dtd">
<html lang="en" xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="refresh" content="2; URL=http://localhost:631/$i" />
<title>CUPS $i</title>
</head>
<body bgcolor="#cccc99" text="#000000" link="#0000ff" vlink="#ff00ff">
<p>You are trying to access the CUPS admin frontend through reading the files.
The correct way to access the CUPS admin frontend is pointing your browser at
<a href="http://localhost:631/">http://localhost:631/</a>.</p>
<p>You should be automatically redirected to the correct URL in 2 seconds.
If your browser does not support redirection, please use
<a href="http://localhost:631/$i">this link</a>.</p>
</body>
</html>
EOF
done

# Ship a generic postscript PPD file (#73061)
install -c -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{_datadir}/cups/model

# Remove unshipped files.
rm -rf $RPM_BUILD_ROOT%{_mandir}/cat? $RPM_BUILD_ROOT%{_mandir}/*/cat?

%post
/sbin/chkconfig --add cups || true
/sbin/restart_maybe cups

if [ $1 -eq 1 ]; then
  # First install.  Build ppds.dat.
  /sbin/service cups reload >/dev/null 2>&1 || :
fi
exit 0

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%preun
if [ "$1" = "0" ]; then
	/sbin/service cups stop > /dev/null 2>&1
	/sbin/chkconfig --del cups
fi
exit 0

%postun
if [ "$1" -ge "1" ]; then
	/sbin/service cups condrestart > /dev/null 2>&1
fi
exit 0

%triggerin -- samba-client
ln -sf ../../../bin/smbspool %{_libdir}/cups/backend/smb || :
exit 0

%triggerun -- samba-client
[ $2 = 0 ] || exit 0
rm -f %{_libdir}/cups/backend/smb

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%dir %attr(0755,lp,sys) /etc/cups
%dir %attr(0711,lp,sys) /etc/cups/certs
%config(noreplace) %attr(0600,lp,sys) /etc/cups/classes.conf
%config(noreplace) %attr(0600,lp,sys) /etc/cups/cupsd.conf
%config(noreplace) %attr(0600,lp,sys) /etc/cups/printers.conf
%config(noreplace) /etc/cups/client.conf
/etc/cups/interfaces
/etc/cups/mime.types
/etc/cups/mime.convs
%dir %attr(0755,lp,sys) /etc/cups/ppd
/etc/pam.d/cups
%doc %{_docdir}/cups-%{version}
%config %{_initdir}/cups
%{_bindir}/cancel*
%{_bindir}/enable*
%{_bindir}/disable*
%{_bindir}/lp*
%{_libdir}/cups
%{_mandir}/man?/*
%{_sbindir}/*
%{_datadir}/cups
%{_datadir}/locale/*/*
%dir %attr(1700,lp,sys) /var/spool/cups/tmp
%dir %attr(0700,lp,sys) /var/spool/cups
%dir %attr(0755,lp,sys) /var/log/cups
%config(noreplace) %{_sysconfdir}/xinetd.d/cups-lpd
%config(noreplace) %{_sysconfdir}/logrotate.d/cups
%{_datadir}/pixmaps/cupsprinter.png

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root)
%{_bindir}/cups-config
%{_libdir}/*.so
%{_libdir}/*.a
%{_includedir}/cups

%changelog
* Thu Sep 16 2004 Oystein Viggen <oysteivi at trustix dot com> 1.1.19-7tr
- Patched a DoS, CAN-2004-0558

* Thu Jun 26 2003 Gerald Dachs <gda at trustix dot org> 1.1.19-6tr
- moved foomatic-filters to an own package to prevent double inclusion
  of files

* Thu Jun 26 2003 Gerald Dachs <gda at trustix dot org> 1.1.19-5tr
- added package foomatic-filters
  based on work by Derek Battams derek at battams dot ca>

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 1.1.19-4tr
- Big rebuild

* Tue Jun 10 2003 Chr. Toldnes <christht at trustix dot org> 1.1.18-3ct
- Removed french manual pages.

* Wed May 28 2003 Gerald Dachs <gda at trustix dot org> 1.1.18-2gd
- reinserted patch9 for generation of pdds data

* Tue May 27 2003 Gerald Dachs <gda at trustix dot org> 1.1.19-1gd
- new upstream version, fixes a denial-of-service attack vulnerability 

* Wed Apr 23 2003 Gerald Dachs <gda at trustix dot org> 1.1.18-3gd
- doesn't start anymore on boot by default 
- cleaned up requirements, libpng10 is not need anymore

* Mon Apr 14 2003 Gerald Dachs <gda at trustix dot org> 1.1.18-2gd
- changed requirements
- rebuild against new libpng10, libjpg, libtiff

* Thu Apr 10 2003 Gerald Dachs <gda at trustix dot org> 1.1.18-1gd
- initial release
